package dev.shadowsoffire.apotheosis.adventure.socket.gem.cutting;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import dev.shadowsoffire.apotheosis.adventure.Adventure;
import dev.shadowsoffire.apotheosis.adventure.affix.AffixHelper;
import dev.shadowsoffire.apotheosis.adventure.loot.LootRarity;
import dev.shadowsoffire.apotheosis.adventure.loot.RarityRegistry;
import dev.shadowsoffire.apotheosis.adventure.socket.gem.GemInstance;
import dev.shadowsoffire.apotheosis.adventure.socket.gem.cutting.GemCuttingMenu;
import dev.shadowsoffire.placebo.reload.DynamicHolder;
import net.minecraft.world.item.ItemStack;

public class RarityUpgrade implements GemCuttingMenu.GemCuttingRecipe {
  public boolean matches(ItemStack gem, ItemStack left, ItemStack bot, ItemStack right) {
    GemInstance g = GemInstance.unsocketed(gem);
    GemInstance g2 = GemInstance.unsocketed(bot);
    if (!g.isValidUnsocketed() || !g2.isValidUnsocketed() || g.gem() != g2.gem() || g.rarity() != g2.rarity())
      return false; 
    if (g.isMaxRarity())
      return false; 
    if (left.m_41720_() != Adventure.Items.GEM_DUST.get() || left.m_41613_() < GemCuttingMenu.getDustCost((LootRarity)g.rarity().get()))
      return false; 
    if (!RarityRegistry.isMaterial(right.m_41720_()))
      return false; 
    DynamicHolder<LootRarity> matRarity = RarityRegistry.getMaterialRarity(right.m_41720_());
    DynamicHolder<LootRarity> gemRarity = g.rarity();
    if (matRarity == gemRarity)
      return (right.m_41613_() >= 3); 
    if (matRarity == RarityRegistry.next(gemRarity))
      return (right.m_41613_() >= 1); 
    return (matRarity == RarityRegistry.prev(gemRarity) && right.m_41613_() >= 9);
  }
  
  public ItemStack getResult(ItemStack gem, ItemStack left, ItemStack bot, ItemStack right) {
    ItemStack out = gem.m_41777_();
    AffixHelper.setRarity(out, (LootRarity)RarityRegistry.next(AffixHelper.getRarity(out)).get());
    return out;
  }
  
  public void decrementInputs(ItemStack gem, ItemStack left, ItemStack bot, ItemStack right) {
    DynamicHolder<LootRarity> matRarity = RarityRegistry.getMaterialRarity(right.m_41720_());
    DynamicHolder<LootRarity> gemRarity = GemInstance.unsocketed(gem).rarity();
    gem.m_41774_(1);
    left.m_41774_(GemCuttingMenu.getDustCost((LootRarity)gemRarity.get()));
    bot.m_41774_(1);
    right.m_41774_((matRarity == gemRarity) ? 3 : ((matRarity == RarityRegistry.next(gemRarity)) ? 1 : 9));
  }
}
